--[[

	You can change the alpha here if you are not pleased with the default
	Accepted numbers range from 0.01 (barely visible) up to 1.0 (fully visible)

--]]
local ReadyAlpha = 0.3
local CooldownAlpha = 1

--[[

	If you want to disable this addon on one or more bars then you will
	need to uncomment, remove -- from the lines you can find below.

	As an example if you're using blizzard original and you want to
	disable this on your main bar along with stealth/vehicles
	and also the bars to the right on your screen it would look like this.

	-- Blizzard original
	["ActionButton"] = true,
	--["MultiBarBottomLeftButton"] = true,
	--["MultiBarBottomRightButton"] = true,
	["MultiBarRightButton"] = true,
	["MultiBarLeftButton"] = true,
	--["ShapeshiftButton"] = true,
	["BonusActionButton"] = true,
	--["PetActionButton"] = true,
	
	Do note that if you switch to another bar addon you should add
	the -- back or get a fresh copy and start over.

--]]
local IgnoreTheese = {

		-- Blizzard original
		--["ActionButton"] = true,
		--["MultiBarBottomLeftButton"] = true,
		--["MultiBarBottomRightButton"] = true,
		--["MultiBarRightButton"] = true,
		--["MultiBarLeftButton"] = true,
		--["ShapeshiftButton"] = true,
		--["BonusActionButton"] = true,
		--["PetActionButton"] = true,

		-- Bartender4
		--["Bar1"] = { ["BT4Button"] = 12 },
		--["Bar2"] = { ["BT4Button"] = 24 },
		--["Bar3"] = { ["BT4Button"] = 36 },
		--["Bar4"] = { ["BT4Button"] = 48 },
		--["Bar5"] = { ["BT4Button"] = 60 },
		--["Bar6"] = { ["BT4Button"] = 72 },
		--["BT4PetButton"] = NUM_PET_ACTION_SLOTS,
		--["BT4StanceButton"] = NUM_SHAPESHIFT_SLOTS,

		-- Dominos											-- Don't touch these comments
		--["ActionButton"] = true,							-- Bar 1
		--["BonusActionButton"] = true,						-- Bar 2
		--["MultiBarRightButton"] = true,					-- Bar 3
		--["MultiBarLeftButton"] = true,					-- Bar 4
		--["MultiBarBottomRightButton"] = true,				-- Bar 5
		--["MultiBarBottomLeftButton"] = true,				-- Bar 6
		--["Bar7"] = { ["DominosActionButton"] = 12 },		-- Bar 7
		--["Bar8"] = { ["DominosActionButton"] = 24 },		-- Bar 8
		--["Bar9"] = { ["DominosActionButton"] = 36 },		-- Bar 9
		--["Bar10"] = { ["DominosActionButton"] = 48 },		-- Bar 10
		--["DominosClassButton"] = true,					-- Stance/Aura
		--["PetActionButton"] = true,

		-- rActionBarStyler
		--["ActionButton"] = true,
		--["MultiBarBottomLeftButton"] = true,
		--["MultiBarBottomRightButton"] = true,
		--["MultiBarRightButton"] = true,
		--["MultiBarLeftButton"] = true,
		--["ShapeshiftButton"] = true,
		--["BonusActionButton"] = true,
		--["PetActionButton"] = true,

}

-- DO NOT TOUCH ANYTHING BELOW

local IgnoredButton = {}
for b,n in pairs(IgnoreTheese) do
	if n==true then
		local i=1
		while _G[b..i] do
			IgnoredButton[b..i] = true
			i=i+1
		end
	elseif type(n)=="number" then
		for i=1,n do
			IgnoredButton[b..i] = true
		end
	elseif type(n)=="table" then
		for k,v in pairs(n) do
			for i=v-11,v do
				IgnoredButton[k..i] = true
			end
		end
	end
end

local CooldownStart = function(self, start, duration)
	if self:GetParent():GetAlpha()>0 and start>0 and duration>1.5 then
		self:GetParent():SetAlpha(CooldownAlpha)
	end
end

local CooldownEnd = function(self)
	if self:GetParent():GetAlpha() > 0 then
		self:GetParent():SetAlpha(ReadyAlpha)
	end
end

local InitButtons = function(name)
	local i=1
	while _G[name..i] do
		if not IgnoredButton[_G[name..i]:GetName()] then
			local b=_G[name..i]
			local c=_G[name..i.."Cooldown"]
			if b:GetAlpha() > 0 then
				if c:IsVisible() then
					b:SetAlpha(CooldownAlpha)
				else
					b:SetAlpha(ReadyAlpha)
				end
			end
			c:HookScript("OnHide", CooldownEnd)
			hooksecurefunc(c, "SetCooldown", CooldownStart)
		end
		i=i+1
	end
end

local DoButtons = function(name,alpha)
	local i=1
	while _G[name..i] do
		if alpha or alpha==0 then
			_G[name..i]:SetAlpha(alpha)
		else
			local b=_G[name..i]
			local c=_G[name..i.."Cooldown"]
			if c:IsVisible() then
				b:SetAlpha(CooldownAlpha)
			else
				b:SetAlpha(ReadyAlpha)
			end
		end
		i=i+1
	end
end

local f=CreateFrame("Frame")
f:SetScript("OnEvent",function(self,event,...)
	if IsAddOnLoaded("Bartender4") then
		InitButtons("BT4Button")
		InitButtons("BT4PetButton")
		InitButtons("BT4StanceButton")
	elseif IsAddOnLoaded("Dominos") then
		InitButtons("ActionButton")
		InitButtons("BonusActionButton")
		InitButtons("MultiBarBottomLeftButton")
		InitButtons("MultiBarBottomRightButton")
		InitButtons("MultiBarLeftButton")
		InitButtons("MultiBarRightButton")
		InitButtons("DominosActionButton")
		InitButtons("PetActionButton")
		InitButtons("DominosClassButton")
	else
		InitButtons("ActionButton")
		InitButtons("BonusActionButton")
		InitButtons("MultiBarBottomLeftButton")
		InitButtons("MultiBarBottomRightButton")
		InitButtons("MultiBarLeftButton")
		InitButtons("MultiBarRightButton")
		InitButtons("PetActionButton")
		InitButtons("ShapeshiftButton")
	end
	if IsAddOnLoaded("rActionBarStyler") then
		if not IgnoreTheese["ActionButton"] then
			BonusActionBarFrame:HookScript("OnHide", function(self) DoButtons("ActionButton") end)
			if ActionButton1:GetAlpha() == 0 then
				local function BarOne() if not BonusActionBarFrame:IsShown() then DoButtons("ActionButton") end end
				for i=1,12 do _G["ActionButton"..i]:HookScript("OnEnter", BarOne) end
				rABS_Bar1Holder:SetScript("OnEnter", BarOne)
			end
		end
		if not IgnoreTheese["BonusActionButton"] and BonusActionButton1:GetAlpha() == 0 then
			local function BarOneBonus() if BonusActionBarFrame:IsShown() then DoButtons("BonusActionButton") end end
			for i=1,12 do _G["BonusActionButton"..i]:HookScript("OnEnter", BarOneBonus) end
			rABS_Bar1Holder:HookScript("OnEnter", BarOneBonus)
		end
		if not IgnoreTheese["MultiBarBottomLeftButton"] and MultiBarBottomLeftButton1:GetAlpha() == 0 then
			local function BarTwo() DoButtons("MultiBarBottomLeftButton") end
			for i=1,12 do _G["MultiBarBottomLeftButton"..i]:HookScript("OnEnter", BarTwo) end
			rABS_Bar2Holder:SetScript("OnEnter", BarTwo)
		end
		if not IgnoreTheese["MultiBarBottomRightButton"] and MultiBarBottomRightButton1:GetAlpha() == 0 then
			local function BarThree() DoButtons("MultiBarBottomRightButton") end
			for i=1,12 do _G["MultiBarBottomRightButton"..i]:HookScript("OnEnter", BarThree) end
			rABS_Bar3Holder:SetScript("OnEnter", BarThree)
		end
		if not IgnoreTheese["MultiBarLeftButton"] and MultiBarRightButton1:GetAlpha() == 0 then
			local function BarLeft() DoButtons("MultiBarLeftButton") end
			for i=1,12 do _G["MultiBarLeftButton"..i]:HookScript("OnEnter", BarLeft) end
			for i=1,12 do _G["MultiBarRightButton"..i]:HookScript("OnEnter", BarLeft) end
			rABS_Bar45Holder:HookScript("OnEnter", BarLeft)
		end
		if not IgnoreTheese["MultiBarRightButton"] and MultiBarRightButton1:GetAlpha() == 0 then
			local function BarRight() DoButtons("MultiBarRightButton") end
			for i=1,12 do _G["MultiBarRightButton"..i]:HookScript("OnEnter", BarRight) end
			for i=1,12 do _G["MultiBarLeftButton"..i]:HookScript("OnEnter", BarRight) end
			rABS_Bar45Holder:HookScript("OnEnter", BarRight)
		end
		if not IgnoreTheese["ShapeshiftButton"] and ShapeshiftButton1:GetAlpha() == 0 then
			local function BarShape() DoButtons("ShapeshiftButton",ReadyAlpha) end
			for i=1,NUM_SHAPESHIFT_SLOTS do _G["ShapeshiftButton"..i]:HookScript("OnEnter", BarShape) end
			rABS_ShapeShiftHolder:SetScript("OnEnter", BarShape)
		end
		if not IgnoreTheese["PetActionButton"] and PetActionButton1:GetAlpha() == 0 then
			local function BarPet() if PetHasActionBar() then DoButtons("PetActionButton") end end
			for i=1,NUM_PET_ACTION_SLOTS do _G["PetActionButton"..i]:HookScript("OnEnter", BarPet) end
			rABS_PetBarHolder:SetScript("OnEnter", BarPet)
		end
	end
	if IsAddOnLoaded("v6ui") then
		BonusActionBarFrame:HookScript("OnHide", function(self) DoButtons("ActionButton") end)
	end
	if IsAddOnLoaded("Geist") then
		InitButtons("GeistButton")
	end
	IgnoredButton = nil
	IgnoreTheese = nil
	InitButtons = nil
	f:UnregisterAllEvents()
	f:SetScript("OnEvent",nil)
end)
f:RegisterEvent("PLAYER_ENTERING_WORLD")